/* ascii.c - The ASCII Table
 * @BAKE cc $@ -o $* $+
 */
#include <stdio.h>
#include <uchar.h>

int main(void)
{
  unsigned int c;
  const char codes[32][4] =
    { "NUL", "SOH", "STX", "ETX", "EOT", "ENQ", "ACK", "BEL",  "BS", "TAB",  "LF",
       "VT",  "FF",  "CR",  "SO",  "SI", "DLE", "DC1", "DC2", "DC3", "DC4", "NAK",
      "SYN", "ETB", "CAN",  "EM", "SUB", "ESC",  "FS",  "GS",  "RS", "US" };
  puts("          DEC  HEX  OCT");
  for (c = 0; c < 127; ++c) {
    if (c == 127)
    { printf( "DEL      %4u %4x %4o\n", c, c, c); }
    else if (c > 31)
    { printf("'%c'      %4u %4x %4o\n", (char16_t) c, c, c, c); }
    else
    { printf( "%3s      %4u %4x %4o\n", codes[c], c, c, c); }
  }
}
